function [s, pt, zt, xit] = simulate_logit(J,T, beta, varxi)
% --------------------------------------------------%
% Simulate logit with outside option
% --------------------------------------------------%
% J = number of products 
% T = number of markets
% beta = coefficient on delta
% varxi = optional standard deviation of market-product demand shock

if nargin > 3
    v =varxi;
else
    v = 0.15;
end

zt = rand(T,J);
xit = randn(T,J)*v;
pt = 2*(zt+rand(T,J)*0.1)+xit;

denominator = 1;
for j = 1:1:J
    denominator = denominator + exp(beta*pt(:,j) + xit(:,j));
end
for j = 1:1:J
    s(:,j) = exp(beta*pt(:,j) + xit(:,j))./denominator;
end
end