function [out,g] = solve_s_nested_flexible(sj,inv_sigma,deltas,J,order,included,maxes,marketvars)
% Solve for s as p moves
if size(sj,1)>1
    sj = sj';
end
if nargin>=8
    extra = size(marketvars,2);
else
    extra = 0;
end

s = sj;
bernO = order;
for xj = 1:1:J
    perm_order = [xj:J, 1:xj-1];
    s_perm = s(:,perm_order);
    % becomes design matrix
    eval(['BERN_x', num2str(xj), ' = [];']);      
% Market shares
for j = 1:1:J
     if included(xj,perm_order(j))==1
        eval(['BERN_x', num2str(xj), ' = [BERN_x', num2str(xj), ',bern(s_perm(:,j), bernO(xj,1))];']);
     end
end

% Market characteristics
if nargin >=8
    for j = 1:1:size(marketvars,2)
        eval(['BERN_x', num2str(xj), ' = [BERN_x', num2str(xj), ',bern(marketvars(:,j), bernO(xj,1))];']);
    end
end
end

for j = 1:1:J
    numVars = sum(included(j,:)) + extra;
    eval(['design', num2str(j), ' = fullInteraction(BERN_x', num2str(j), ',numVars, bernO(j,1));']);
    eval(['out(j,1) = deltas(j,1) - design', num2str(j),'*inv_sigma{j};']);
end


if nargout>1
    g = zeros(J);
    for j1 = 1:1:J
        perm_order = [j1:J, 1:j1-1];
        s_perm = s(:,perm_order);
        numVars = sum(included(j1,:)) + extra;
        for j2 = 1:1:J
            clear temp
            if included(j1,perm_order(j2))==1
                eval(['temp = BERN_x', num2str(j1),';']);
                temp(:,(j2-1)*(bernO(j1,1)+1)+1:j2*(bernO(j1,1)+1)) = dbern(s_perm(:,j2),bernO(j1,1)); 
                temp = fullInteraction(temp,numVars, bernO(j1,1));
                g(j1,perm_order(j2)) = -1*temp*inv_sigma{j1};
            else
                g(j1,perm_order(j2)) = 0;
            end
        end
    end
end
end